## scotch 7.0.4

=== CMakeLists.txt ===
## Copyright 2014-2016,2021-2023 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##
############################################################
##                                                        ##
##   AUTHORS    : Marc FUENTES                            ##
##                Florent PRUVOST                         ##
##                                                        ##
##   FUNCTION   : Top-level CMake configuration file      ##
##                                                        ##
##   DATES      : # Version 7.0  : from : 18 jan 2022     ##
##                                 to     16 jan 2023     ##
##                                                        ##
############################################################

cmake_minimum_required(VERSION 3.10)
project(SCOTCH)
enable_language(C Fortran)

# Add module directory
list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/Modules)

set(SCOTCH_VERSION 7)
set(SCOTCH_RELEASE 0)
set(SCOTCH_PATCHLEVEL 4)
set(SCOTCH_CODENAME "Sankara")

add_definitions(-DSCOTCH_VERSION_NUM=${SCOTCH_VERSION}
  -DSCOTCH_RELEASE_NUM=${SCOTCH_RELEASE}
  -DSCOTCH_PATCHLEVEL_NUM=${SCOTCH_PATCHLEVEL})

set(SCOTCH_VERSION_LONG "${SCOTCH_VERSION}.${SCOTCH_RELEASE}.${SCOTCH_PATCHLEVEL}")

# Set integer size: by default, use compiler int size
set(INTSIZE "" CACHE STRING "Integer size: empty string stands for C compiler int type size")

# Thread support
option(THREADS "Use multi-threading in Scotch and PT-Scotch" ON)

# Use MPI with threads
option(MPI_THREAD_MULTIPLE "Use multi-threading with MPI in PT-Scotch" ON)

# Build PT-Scotch
option(BUILD_PTSCOTCH "Build PT-Scotch" ON)

# Build libESMUMPS
option(BUILD_LIBESMUMPS "Build EsMUMPS library" ON)

# Build libScotchMeTiS
option(BUILD_LIBSCOTCHMETIS "Build ScotchMeTiS library" ON)

# Install our MeTiS header stubs
option(INSTALL_METIS_HEADERS "Install libScotchMeTiS headers in destination directory" ON)

# Compression format options
option(USE_ZLIB "Use ZLIB compression format if found" ON)
option(USE_LZMA "Use LZMA compression format if found" ON)
option(USE_BZ2 "Use BZ2 compression format if found" ON)

# Set fPIC flag when building shared libraries
set(CMAKE_POSITION_INDEPENDENT_CODE ${BUILD_SHARED_LIBS})

# Allow for testing
enable_testing()

add_subdirectory(src)

# Install man pages
install(DIRECTORY man/man1 DESTINATION man FILES_MATCHING PATTERN "*.1")

=== src/CMakeLists.txt ===
## Copyright 2014-2016,2021,2022 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##
############################################################
##                                                        ##
##   AUTHORS    : Marc FUENTES                            ##
##                Florent PRUVOST                         ##
##                Cedric LACHAT (v6.0)                    ##
##                Amaury JACQUES (v6.0)                   ##
##                                                        ##
##   FUNCTION   : Secondary configuration file for CMake  ##
##                                                        ##
##   DATES      : # Version 6.0  : from : 01 sep 2014     ##
##                                 to     01 sep 2021     ##
##                # Version 7.0  : from : 01 sep 2021     ##
##                                 to     26 jan 2023     ##
##                                                        ##
############################################################

# Add general compiler options
add_definitions(-Drestrict=__restrict -DCOMMON_RANDOM_FIXED_SEED -DSCOTCH_RENAME)

# Add OS-specific compiler options
if(APPLE)
  add_definitions(-DCOMMON_OS_MACOS -D_DARWIN_C_SOURCE)
endif(APPLE)
if(MINGW OR MSYS OR WIN32)
  add_definitions(-DCOMMON_OS_WINDOWS)
endif(MINGW OR MSYS OR WIN32)

###################
#  Prerequisites  #
###################

# Bison
find_package(BISON)
if(NOT BISON_FOUND)
  message(FATAL_ERROR "Bison required to compile Scotch and PT-Scotch")
else()
  message(STATUS "Bison found here: ${BISON_EXECUTABLE}")
endif()

# Flex
find_package(FLEX)
if(NOT FLEX_FOUND)
  message(FATAL_ERROR "Flex required to compile Scotch and PT-Scotch")
else()
  message(STATUS "Flex found here: ${FLEX_EXECUTABLE}")
endif()

#############
#  Options  #
#############

# Set integer size
if(NOT INTSIZE STREQUAL "")
  if(INTSIZE STREQUAL "32")
    message(STATUS "Integer size is 32 bits")
    add_definitions(-DINTSIZE32)
  elseif(INTSIZE STREQUAL "64")
    message(STATUS "Integer size is 64 bits")
    add_definitions(-DINTSIZE64)
  else()
    message(FATAL_ERROR "Invalid integer size value")
  endif()
endif()

# Thread support in Scotch
if(THREADS)
  find_package(Threads)
  if(Threads_FOUND)
    add_definitions(-DCOMMON_PTHREAD -DSCOTCH_PTHREAD)
  endif()
  include(CheckPthreadAffinity)
  if(PTHREAD_AFFINITY_LINUX_OK)
    add_definitions(-DCOMMON_PTHREAD_AFFINITY_LINUX)
  endif()
endif()

# decompression libs
if(USE_ZLIB)
  find_package(ZLIB)
endif(USE_ZLIB)

if (USE_BZ2)
  find_package(BZip2)
endif (USE_BZ2)

if (USE_LZMA)
  find_package(LibLZMA)
endif(USE_LZMA)

# MPI
if(BUILD_PTSCOTCH)
  set(MPI_DETERMINE_LIBRARY_VERSION ON)
  find_package(MPI COMPONENTS C)
  if(NOT MPI_C_FOUND)
    message(FATAL_ERROR "MPI required to compile PT-Scotch")
  else()
    string(REGEX MATCHALL "\( Open MPI \)+" found_suite ${MPI_C_LIBRARY_VERSION_STRING})
    if(NOT ${found_suite} STREQUAL "")
      message(STATUS "Found OpenMPI: using '--oversubscribe' policy for testing")
      set(MPIEXEC_PREFLAGS ${MPIEXEC_PREFLAGS} --oversubscribe)
    endif()
  endif()

  if(MPI_THREAD_MULTIPLE)
    if(Threads_FOUND)
      include(CheckMpiThreadMultiple)
      if(MPI_THREAD_MULTIPLE_OK)
        message(STATUS "MPI implementation DOES support MPI_THREAD_MULTIPLE")
        add_definitions(-DSCOTCH_PTHREAD_MPI)
      else()
        message(STATUS "MPI implementation does NOT support MPI_THREAD_MULTIPLE")
      endif()
    endif()
  endif()
endif(BUILD_PTSCOTCH)

# Put libraries in the lib subdirectory
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

# Put executables in the bin subdirectory
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

# Set variables for include directories
set(GENERATED_INCLUDE_DIR ${CMAKE_CURRENT_BINARY_DIR}/include)
set(LIBSCOTCH_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/libscotch)
file(MAKE_DIRECTORY ${GENERATED_INCLUDE_DIR})

# Build Scotch and PT-Scotch libraries
add_subdirectory(libscotch)

# Build Scotch executables
add_subdirectory(scotch)

# Build EsMUMPS library
if(BUILD_LIBESMUMPS)
  add_subdirectory(esmumps)
endif(BUILD_LIBESMUMPS)

# Build ScotchMeTiS library
if(BUILD_LIBSCOTCHMETIS)
  add_subdirectory(libscotchmetis)
endif(BUILD_LIBSCOTCHMETIS)

# Testing
add_subdirectory(check)

####################
#  Export targets  #
####################

# See https://cmake.org/cmake/help/latest/module/CMakePackageConfigHelpers.html
include(CMakePackageConfigHelpers)

set(INCLUDE_INSTALL_DIR "include/" CACHE STRING "Where to install headers relative to prefix")
set(LIBRARY_INSTALL_DIR "lib/" CACHE STRING "Where to install libraries relative to prefix")

configure_package_config_file(${PROJECT_SOURCE_DIR}/cmake/SCOTCHConfig.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/SCOTCHConfig.cmake
  INSTALL_DESTINATION ${LIBRARY_INSTALL_DIR}/cmake/scotch
  PATH_VARS INCLUDE_INSTALL_DIR LIBRARY_INSTALL_DIR)

write_basic_package_version_file(SCOTCHConfigVersion.cmake
  VERSION ${SCOTCH_VERSION_LONG}
  COMPATIBILITY AnyNewerVersion)

# Install config files
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/SCOTCHConfig.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/SCOTCHConfigVersion.cmake
  DESTINATION ${LIBRARY_INSTALL_DIR}/cmake/scotch)

=== src/Makefile ===
## Copyright 2004,2007,2008,2010-2012,2014,2018-2020 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

VERSION	= 7
RELEASE = 0
PATCHLEVEL = 4
CODENAME = "Sankara"

.PHONY				:	clean	default	install	ptscotch	realclean	required	scotch

default				:	scotch

required			:	Makefile.inc	../bin	../include	../lib

Makefile.inc			:
					@echo "#####################################################################"
			        	@echo "BEFORE COMPILING Scotch OR PT-Scotch, YOU SHOULD HAVE AN APPROPRIATE"
					@echo "Makefile.inc FILE IN THIS DIRECTORY. PLEASE LOOK INTO DIRECTORY"
	        			@echo " ./Make.inc FOR AN EXISTING Makefile.inc FILE THAT FITS YOUR NEED, OR"
		        		@echo "USE THEM AS MODELS IN CASE YOU NEED TO BUILD A NEW ONE FOR YOUR"
		        		@echo "PARTICULAR PLATFORM."
			        	@echo "#####################################################################"
			        	@echo "Then, type \"make scotch\" (default) for the sequential library"
			        	@echo "and software, or \"make ptscotch\" for the parallel library and"
			        	@echo "software."
					@exit 1

include Makefile.inc

prefix		?= /usr/local
bindir		?= $(prefix)/bin
includedir	?= $(prefix)/include
includestub     ?= include_stub
includestubdir	?= $(prefix)/$(includestub)
libdir		?= $(prefix)/lib
datarootdir	?= $(prefix)/share
mandir		?= $(datarootdir)/man

../bin				:
					-$(MKDIR) ../bin

../include			:
					-$(MKDIR) ../include

../lib				:
					-$(MKDIR) ../lib

$(bindir)			:
					-$(MKDIR) $(bindir)

$(datarootdir)			:
					-$(MKDIR) $(datarootdir)

$(includedir)			:
					-$(MKDIR) $(includedir)
					-$(MKDIR) $(includestubdir)

$(libdir)			:
					-$(MKDIR) $(libdir)

$(mandir)			:	$(datarootdir)
					-$(MKDIR) $(mandir)

$(mandir)/man1			:	$(mandir)
					-$(MKDIR) $(mandir)/man1

libscotch			:	required
					(cd libscotch ;      $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) scotch && $(MAKE) install)

scotch				:	libscotch
					(cd scotch ;         $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) CODENAME=$(CODENAME) scotch && $(MAKE) install)
					(cd libscotchmetis ; $(MAKE)                                                                scotch && $(MAKE) install)

libptscotch			:	libscotch
					(cd libscotch ;      $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) ptscotch && $(MAKE) ptinstall)

ptscotch			:	libptscotch
					(cd scotch ;         $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) CODENAME=$(CODENAME) ptscotch && $(MAKE) ptinstall)
					(cd libscotchmetis ; $(MAKE)                                                                ptscotch && $(MAKE) ptinstall)

check				:	scotch
					(cd check ; $(MAKE) check)

check_full			:	scotch
					(cd check ; $(MAKE) check_full)

ptcheck				:	ptscotch
					(cd check ; $(MAKE) ptcheck)

ptcheck_full			:	ptscotch
					(cd check ; $(MAKE) ptcheck_full)

esmumps				:	scotch
					(cd esmumps ; $(MAKE) scotch && $(MAKE) install)

escheck				:	esmumps
					(cd check ; $(MAKE) escheck)

ptesmumps			:	scotch	ptscotch
					(cd esmumps ; $(MAKE) ptscotch && $(MAKE) ptinstall)

install				:	required	$(bindir)	$(includedir)	$(libdir)	$(mandir)/man1
					-$(CP) -f ../bin/[agm]*$(EXE) $(bindir)
					-$(CP) -f ../bin/d[agm]*$(EXE) $(bindir)
					-$(CP) -f ../include/*esmumps*.h $(includedir)
					-$(CP) -f ../include/*scotch*.h $(includedir)
					-$(CP) -f ../lib/*esmumps*$(LIB) $(libdir)
					-$(CP) -f ../lib/*scotch*$(LIB) $(libdir)
					-$(CP) -f ../man/man1/*[.]1 $(mandir)/man1

installstub			:	required	$(includedir)
					-$(CP) -f ../include/*metis*.h $(includestubdir)

clean				:	required
					(cd libscotch ;      $(MAKE) clean)
					(cd scotch ;         $(MAKE) clean)
					(cd libscotchmetis ; $(MAKE) clean)
					(cd check ;          $(MAKE) clean)
					(cd esmumps ;        $(MAKE) clean)

realclean			:	required
					(cd libscotch ;      $(MAKE) realclean)
					(cd scotch ;         $(MAKE) realclean)
					(cd libscotchmetis ; $(MAKE) realclean)
					(cd check ;          $(MAKE) realclean)
					(cd esmumps ;        $(MAKE) realclean)
					-$(RM) ../bin/* ../include/* ../lib/*

=== src/check/Makefile ===
## Copyright 2011,2012,2014-2016,2018-2021 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

TMPDIR			= /tmp

SCOTCHBINDIR		= ../../bin
SCOTCHINCDIR		= ../../include
SCOTCHLIBDIR		= ../../lib
SCOTCHTGTDIR		= ../../tgt

LIBESMUMPS		= -lesmumps -lscotch -lscotcherr
LIBPTSCOTCH		= -lptscotch -lscotch -lptscotcherr
LIBSCOTCH		= -lscotch -lscotcherr

DEPESMUMPS		= $(SCOTCHLIBDIR)/libesmumps$(LIB)
DEPPTSCOTCH		= $(SCOTCHLIBDIR)/libptscotch$(LIB)
DEPSCOTCH		= $(SCOTCHLIBDIR)/libscotch$(LIB)

EXECPPROG		?= mpirun
EXECPFLAGS		?= $(if $(findstring Open,$(shell $(EXECPPROG) --version)),--oversubscribe)
# EXECPFLAGS		+= valgrind --leak-check=full --show-leak-kinds=all --track-origins=yes
EXECS			?=
# EXECS			+= valgrind --leak-check=full --show-leak-kinds=all --track-origins=yes
EXECP3			?= $(EXECPPROG) -n 3 $(EXECPFLAGS)
EXECP4			?= $(EXECPPROG) -n 4 $(EXECPFLAGS)

PROGDIFF		?= diff -q

##
##  General inference rules.
##

include ../Makefile.inc

%$(OBJ)	:	%.c
				$(CC) $(CFLAGS) $(CLIBFLAGS) -I$(SCOTCHINCDIR) -c $(<) -o $(@)

%_v3$(EXE) :	%.c
				$(CC) $(CFLAGS) -I$(SCOTCHINCDIR) -L$(SCOTCHLIBDIR) $(<) -o $(@) -lscotchmetisv3 $(SCOTCHLIBS) $(LDFLAGS)

%_v5$(EXE) :	%.c
				$(CC) $(CFLAGS) -I$(SCOTCHINCDIR) -L$(SCOTCHLIBDIR) $(<) -o $(@) -lscotchmetisv5 $(SCOTCHLIBS) $(LDFLAGS)

%$(EXE)	:	%.c
				$(CC) $(CFLAGS) -I$(SCOTCHINCDIR) -L$(SCOTCHLIBDIR) $(<) -o $(@) $(SCOTCHLIBS) $(LDFLAGS)

%_v3$(EXE):	%.f90
				$(FC) $(FFLAGS) -I$(SCOTCHINCDIR) -L$(SCOTCHLIBDIR) $(<) -o $(@) -lscotchmetisv3 $(SCOTCHLIBS) $(LDFLAGS)

%_v5$(EXE):	%.f90
				$(FC) $(FFLAGS) -I$(SCOTCHINCDIR) -L$(SCOTCHLIBDIR) $(<) -o $(@) -lscotchmetisv5 $(SCOTCHLIBS) $(LDFLAGS)

##
##  Project rules.
##

.PHONY				:	check	ptcheck	clean	realclean

check				:	realclean
					$(MAKE) CC="$(CCS)" CCD="$(CCS)" SCOTCHLIBS="$(LIBSCOTCH)" $(CHECKSCOTCH)

check_full			:	realclean
					$(MAKE) CC="$(CCS) -DSCOTCH_DEBUG_FULL" CCD="$(CCS)" SCOTCHLIBS="$(LIBSCOTCH)" check_prog_full

ptcheck				:	realclean
					$(MAKE) CFLAGS="$(CFLAGS) -DSCOTCH_PTSCOTCH" CC="$(CCP)" SCOTCHLIBS="$(LIBPTSCOTCH)" $(CHECKPTSCOTCH)

ptcheck_full			:	realclean
					$(MAKE) CFLAGS="$(CFLAGS) -DSCOTCH_PTSCOTCH" CC="$(CCP)" SCOTCHLIBS="$(LIBPTSCOTCH)" check_prog_dfull

escheck				:	realclean
					$(MAKE) CFLAGS="$(CFLAGS)" CC="$(CCP)" SCOTCHLIBS="$(LIBESMUMPS)" $(CHECKESMUMPS)

clean				:
					-$(RM) *~ *$(OBJ)

realclean			:	clean
					-$(RM) 				\
					test_common_file_compress	\
					test_common_random		\
					test_common_thread		\
					test_fibo			\
					test_libesmumps			\
					test_libmetis_v3		\
					test_libmetis_v5		\
					test_libmetis_dual_v3		\
					test_libmetis_dual_v5		\
					test_libmetis_dual_f_v3		\
					test_libmetis_dual_f_v5		\
					test_scotch_arch		\
					test_scotch_arch_deco		\
					test_scotch_context		\
					test_scotch_graph_coarsen	\
					test_scotch_graph_color		\
					test_scotch_graph_diam		\
					test_scotch_graph_dump2		\
					test_scotch_graph_dump2.c	\
					test_scotch_graph_induce	\
					test_scotch_graph_map		\
					test_scotch_graph_map_copy	\
					test_scotch_graph_order		\
					test_scotch_graph_part_ovl	\
					test_scotch_dgraph_band		\
					test_scotch_dgraph_check	\
					test_scotch_dgraph_coarsen	\
					test_scotch_dgraph_grow		\
					test_scotch_dgraph_induce	\
					test_scotch_dgraph_redist	\
					test_scotch_mesh_graph		\
					test_strat_par			\
					test_strat_seq

##
##  Test cases dependencies.
##

CHECKSCOTCH = 		check_common_file_compress		\
			check_common_random			\
			check_common_thread			\
			check_fibo				\
			check_strat_seq				\
			check_scotch_arch			\
			check_scotch_arch_deco			\
			check_scotch_context			\
			check_scotch_graph_coarsen		\
			check_scotch_graph_color		\
			check_scotch_graph_diam			\
			check_scotch_graph_dump			\
			check_scotch_graph_induce		\
			check_scotch_graph_map			\
			check_scotch_graph_map_copy		\
			check_scotch_graph_order		\
			check_scotch_graph_part_ovl		\
			check_scotch_mesh_graph			\
			check_libmetis_v3			\
			check_libmetis_v5			\
			check_libmetis_dual_v3			\
			check_libmetis_dual_v5			\
			check_libmetis_dual_f_v3		\
			check_libmetis_dual_f_v5		\
			check_prog_amk				\
			check_prog_amk_grf			\
			check_prog_acpl				\
			check_prog_gbase			\
			check_prog_gmap				\
			check_prog_gmk				\
			check_prog_gmk_msh			\
			check_prog_gord				\
			check_prog_gord_block			\
			check_prog_gotst			\
			check_prog_gout				\
			check_prog_gpart			\
			check_prog_gpart_clustering		\
			check_prog_gpart_overlap		\
			check_prog_gpart_remap			\
			check_prog_gscat			\
			check_prog_gtst				\
			check_prog_mmk				\
			check_prog_mord

CHECKPTSCOTCH = 	check_strat_par				\
			check_scotch_dgraph_check		\
			check_scotch_dgraph_band		\
			check_scotch_dgraph_coarsen		\
			check_scotch_dgraph_grow		\
			check_scotch_dgraph_induce      	\
			check_scotch_dgraph_redist		\
			check_prog_dgord			\
			check_prog_dgpart			\
			check_prog_dgscat-dggath		\
			check_prog_dgtst

CHECKESMUMPS = 		check_libesmumps

##
##  Sequential library tests.
##

check_common_file_compress	:	test_common_file_compress
					-cp "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					$(EXECS) ./test_common_file_compress "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf.gz"
					$(EXECS) ./test_common_file_compress "$(TMPDIR)/bump_b1.grf.gz" "$(TMPDIR)/bump_b1.grf"
					$(PROGDIFF) "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					-cp "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					$(EXECS) ./test_common_file_compress "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf.bz2"
					$(EXECS) ./test_common_file_compress "$(TMPDIR)/bump_b1.grf.bz2" "$(TMPDIR)/bump_b1.grf"
					$(PROGDIFF) "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					-cp "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					$(EXECS) ./test_common_file_compress "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf.lzma"
					$(EXECS) ./test_common_file_compress "$(TMPDIR)/bump_b1.grf.lzma" "$(TMPDIR)/bump_b1.grf"
					$(PROGDIFF) "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"

test_common_file_compress	:	test_common_file_compress.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_common_random		:	test_common_random
					$(EXECS) ./test_common_random "$(TMPDIR)/rand.dat" 0
					$(EXECS) ./test_common_random "$(TMPDIR)/rand.dat" 1

test_common_random		:	test_common_random.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_common_thread		:	test_common_thread
					$(EXECS) ./test_common_thread

test_common_thread		:	test_common_thread.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_fibo			:	test_fibo
					$(EXECS) ./test_fibo

test_fibo			:	test_fibo.c			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_libesmumps		:	test_libesmumps
					$(EXECS) ./test_libesmumps data/bump.grf
					$(EXECS) ./test_libesmumps data/bump_imbal_32.grf

test_libesmumps			:	test_libesmumps.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libesmumps$(LIB)

##

check_libmetis_v3		:	test_libmetis_v3
					$(EXECS) ./test_libmetis_v3 data/bump.grf
					$(EXECS) ./test_libmetis_v3 data/bump_b1.grf
					$(EXECS) ./test_libmetis_v3 data/bump_imbal_32.grf

test_libmetis_v3		:	test_libmetis.c			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetisv3$(LIB)

check_libmetis_v5		:	test_libmetis_v5
					$(EXECS) ./test_libmetis_v5 data/bump.grf
					$(EXECS) ./test_libmetis_v5 data/bump_b1.grf
					$(EXECS) ./test_libmetis_v5 data/bump_imbal_32.grf

test_libmetis_v5		:	test_libmetis.c			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetisv5$(LIB)

##

check_libmetis_dual_v3		:	test_libmetis_dual_v3
					$(EXECS) ./test_libmetis_dual_v3
					$(EXECS) ./test_libmetis_dual_v3 1

test_libmetis_dual_v3		:	test_libmetis_dual.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetisv3$(LIB)

check_libmetis_dual_v5		:	test_libmetis_dual_v5
					$(EXECS) ./test_libmetis_dual_v5
					$(EXECS) ./test_libmetis_dual_v5 1

test_libmetis_dual_v5		:	test_libmetis_dual.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetisv5$(LIB)

##

check_libmetis_dual_f_v3	:	test_libmetis_dual_f_v3
					$(EXECS) ./test_libmetis_dual_f_v3

test_libmetis_dual_f_v3		:	test_libmetis_dual_f.f90	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetisv3$(LIB)

check_libmetis_dual_f_v5	:	test_libmetis_dual_f_v5
					$(EXECS) ./test_libmetis_dual_f_v5

test_libmetis_dual_f_v5		:	test_libmetis_dual_f.f90	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetisv5$(LIB)

##

check_scotch_arch		:	test_scotch_arch
					$(EXECS) ./test_scotch_arch "$(TMPDIR)/arch.tgt"

test_scotch_arch		:	test_scotch_arch.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_arch_deco		:	test_scotch_arch_deco
					$(EXECS) ./test_scotch_arch_deco data/m4x4.grf "$(TMPDIR)/arch2.tgt"
#					$(EXECS) ./test_scotch_arch_deco data/m4x4_b100000.grf "$(TMPDIR)/arch2.tgt"

test_scotch_arch_deco		:	test_scotch_arch_deco.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_context		:	test_scotch_context
					$(EXECS) ./test_scotch_context data/bump_b1.grf

test_scotch_context		:	test_scotch_context.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_graph_coarsen	:	test_scotch_graph_coarsen
					$(EXECS) ./test_scotch_graph_coarsen data/bump.grf
					$(EXECS) ./test_scotch_graph_coarsen data/bump_b100000.grf

test_scotch_graph_coarsen	:	test_scotch_graph_coarsen.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_graph_color	:	test_scotch_graph_color
					$(EXECS) ./test_scotch_graph_color data/bump.grf
					$(EXECS) ./test_scotch_graph_color data/bump_b100000.grf

test_scotch_graph_color		:	test_scotch_graph_color.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_graph_diam		:	test_scotch_graph_diam
					$(EXECS) ./test_scotch_graph_diam data/bump_b100000.grf
					$(EXECS) ./test_scotch_graph_diam data/m16x16_b100000.grf
					$(EXECS) ./test_scotch_graph_diam data/p2-p2.grf

test_scotch_graph_diam		:	test_scotch_graph_diam.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_graph_dump		:	test_scotch_graph_dump2
					$(EXECS) ./test_scotch_graph_dump2 $(TMPDIR)/m16x16_b1.grf
					$(PROGDIFF) "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"

test_scotch_graph_dump2		:	test_scotch_graph_dump2.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

test_scotch_graph_dump2.c	:	test_scotch_graph_dump.c

=== src/esmumps/CMakeLists.txt ===
## Copyright 2014-2016,2021,2022 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##
############################################################
##                                                        ##
##   AUTHORS    : Cedric LACHAT                           ##
##                Amaury JACQUES                          ##
##                Florent PRUVOST                         ##
##                Marc FUENTES                            ##
##                Francois PELLEGRINI                     ##
##                                                        ##
##   FUNCTION   : Secondary configuration file for CMake  ##
##                                                        ##
##   DATES      : # Version 6.0  : from : 01 sep 2014     ##
##                                 to     01 sep 2021     ##
##                # Version 7.0  : from : 01 sep 2021     ##
##                                 to     21 apr 2022     ##
##                # Version 7.1  : from : 11 dec 2022     ##
##                                 to     11 dec 2022     ##
##                                                        ##
############################################################

set_source_files_properties(${GENERATED_INCLUDE_DIR}/scotch.h PROPERTIES GENERATED 1)

################
#  libEsMUMPS  #
################

# esmumps.h
add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/esmumps.h
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/library.h ${GENERATED_INCLUDE_DIR}/esmumps.h
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/library.h
  COMMENT "Copy esmumps.h to include directory")

add_custom_target(esmumps_h
  DEPENDS "${GENERATED_INCLUDE_DIR}/esmumps.h")

# libEsMUMPS
set(esmumps_src
  dof.c
  esmumps.c
  graph_graph.c
  library_esmumps.c
  library_esmumps_f.c
  library_esmumps_strats.c
  order.c
  order_check.c
  order_io.c
  order_scotch_graph.c
  symbol.c
  symbol_check.c
  symbol_cost.c
  symbol_fax_graph.c
  symbol_fax.c)

set(esmumps_headers
  module.h
  library.h
  ${GENERATED_INCLUDE_DIR}/scotch.h
  ${LIBSCOTCH_INCLUDE_DIR}/common.h
  graph.h
  dof.h
  symbol.h
  order.h
  fax.h
  ${GENERATED_INCLUDE_DIR}/esmumps.h)

add_library(esmumps ${esmumps_src} ${esmumps_headers})
set_target_properties(esmumps PROPERTIES PUBLIC_HEADER "${GENERATED_INCLUDE_DIR}/esmumps.h")

if(APPLE)
  set_target_properties(esmumps PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
endif(APPLE)

target_include_directories(esmumps PRIVATE
  $<BUILD_INTERFACE:${LIBSCOTCH_INCLUDE_DIR}>
  $<BUILD_INTERFACE:${GENERATED_INCLUDE_DIR}>
  $<INSTALL_INTERFACE:include>)

target_link_libraries(esmumps PRIVATE scotch)

add_dependencies(esmumps scotch_h)

add_executable(test_esmumps test_esmumps.c)
set_target_properties(test_esmumps PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
target_include_directories(test_esmumps PRIVATE ${GENERATED_INCLUDE_DIR}/)
target_link_libraries(test_esmumps PRIVATE esmumps scotch scotcherrexit)
add_dependencies(test_esmumps scotch_h)

add_executable(test_fax test_fax.c)
set_target_properties(test_fax PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
target_include_directories(test_fax PRIVATE ${GENERATED_INCLUDE_DIR}/)
target_link_libraries(test_fax PRIVATE esmumps scotch scotcherrexit)
add_dependencies(test_fax scotch_h)

# libEsMUMPS targets install
install(EXPORT esmumpsTargets
  FILE esmumpsTargets.cmake
  NAMESPACE SCOTCH::
  DESTINATION lib/cmake/scotch)

install(TARGETS esmumps
  EXPORT esmumpsTargets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  PUBLIC_HEADER DESTINATION include)

# Dummy PTEsMUMPS library file
add_library(ptesmumps ${esmumps_src} ${esmumps_headers})

if(APPLE)
  set_target_properties(ptesmumps PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
endif(APPLE)

set_target_properties(ptesmumps PROPERTIES PUBLIC_HEADER "${GENERATED_INCLUDE_DIR}/esmumps.h")

target_include_directories(ptesmumps PRIVATE
  $<BUILD_INTERFACE:${LIBSCOTCH_INCLUDE_DIR}>
  $<BUILD_INTERFACE:${GENERATED_INCLUDE_DIR}>
  $<INSTALL_INTERFACE:include>)

target_link_libraries(ptesmumps PRIVATE scotch)
add_dependencies(ptesmumps scotch_h)

# libptesmumps targets install
install(EXPORT ptesmumpsTargets
  FILE ptesmumpsTargets.cmake
  NAMESPACE SCOTCH::
  DESTINATION lib/cmake/scotch)

install(TARGETS ptesmumps
  EXPORT ptesmumpsTargets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  PUBLIC_HEADER DESTINATION include)

=== src/libscotch/CMakeLists.txt ===
## Copyright 2014-2016,2021-2023 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##
############################################################
##                                                        ##
##   AUTHORS    : Cedric LACHAT                           ##
##                Amaury JACQUES                          ##
##                Florent PRUVOST                         ##
##                Marc FUENTES                            ##
##                                                        ##
##   FUNCTION   : Secondary configuration file for CMake  ##
##                                                        ##
##   DATES      : # Version 6.0  : from : 01 sep 2014     ##
##                                 to     01 sep 2021     ##
##                # Version 7.0  : from : 01 sep 2021     ##
##                                 to     26 jan 2023     ##
##                                                        ##
############################################################

################
#  dummysizes  #
################

add_executable(dummysizes dummysizes.c)
set_target_properties(dummysizes PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
if(BUILD_PTSCOTCH)
  find_package(MPI COMPONENTS C)
  if(NOT MPI_C_FOUND)
    message(FATAL_ERROR "MPI required to compile PT-Scotch")
  endif()
  add_executable(ptdummysizes dummysizes.c)
  set_target_properties(ptdummysizes PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  target_link_libraries(ptdummysizes PRIVATE MPI::MPI_C)
  add_dependencies(ptdummysizes scotch_h)
  set_target_properties(ptdummysizes PROPERTIES
    COMPILE_FLAGS -DSCOTCH_PTSCOTCH)
endif(BUILD_PTSCOTCH)

##############
#  scotch.h  #
##############

# Generate scotch.h
add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/scotch.h
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/library.h ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $<TARGET_FILE:dummysizes> ${CMAKE_CURRENT_BINARY_DIR}/library.h ${GENERATED_INCLUDE_DIR}/scotch.h DEPENDS dummysizes
  DEPENDS library.h
  COMMENT "Generate scotch.h")
add_custom_target(scotch_h
  DEPENDS "${GENERATED_INCLUDE_DIR}/scotch.h")

# Generate scotchf.h
add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/scotchf.h
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/library_f.h ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $<TARGET_FILE:dummysizes> ${CMAKE_CURRENT_BINARY_DIR}/library_f.h ${GENERATED_INCLUDE_DIR}/scotchf.h DEPENDS dummysizes
  DEPENDS library.h
  COMMENT "Generate scotchf.h")
add_custom_target(scotchf_h
  DEPENDS "${GENERATED_INCLUDE_DIR}/scotchf.h")

################
#  ptscotch.h  #
################

# Generate ptscotch.h
if(BUILD_PTSCOTCH)
  add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/ptscotch.h
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/library_pt.h ${CMAKE_CURRENT_BINARY_DIR}
    COMMAND $<TARGET_FILE:ptdummysizes> ${CMAKE_CURRENT_BINARY_DIR}/library_pt.h ${GENERATED_INCLUDE_DIR}/ptscotch.h DEPENDS ptdummysizes
    DEPENDS library_pt.h scotch_h
    COMMENT "Generate ptscotch.h")
  add_custom_target(ptscotch_h
    DEPENDS ${GENERATED_INCLUDE_DIR}/ptscotch.h)

# Generate ptscotchf.h
add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/ptscotchf.h
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/library_pt_f.h ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $<TARGET_FILE:ptdummysizes> ${CMAKE_CURRENT_BINARY_DIR}/library_pt_f.h ${GENERATED_INCLUDE_DIR}/ptscotchf.h DEPENDS ptdummysizes
  DEPENDS library.h
  COMMENT "Generate ptscotchf.h")
add_custom_target(ptscotchf_h
  DEPENDS "${GENERATED_INCLUDE_DIR}/ptscotchf.h")
endif(BUILD_PTSCOTCH)

#################
#  parser_yy.c  #
#################

# Copy parser_yy.y to binary dir
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/parser_yy.y
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/parser_yy.y ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS parser_yy.y
  COMMENT "Copy parser_yy.y to CMake binary directory")
add_custom_target(parser_yy_y DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/parser_yy.y)

# Generate parser_yy.c using Bison
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/parser_yy.c ${CMAKE_CURRENT_BINARY_DIR}/parser_ly.h
  COMMAND ${BISON_EXECUTABLE} "-pscotchyy${SCOTCH_NAME_SUFFIX}" --defines="parser_ly.h" --output="parser_yy.c" parser_yy.y
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/parser_yy.y module.h common.h parser.h parser_yy.h
  COMMENT "Generate parser_yy.c and parser_ly.h using Bison")
add_custom_target(parser_yy_c DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/parser_yy.c ${CMAKE_CURRENT_BINARY_DIR}/parser_ly.h)
add_dependencies(parser_yy_c parser_yy_y)

#################
#  parser_ll.c  #
#################

# Copy parser_ll.l to binary dir
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/parser_ll.l
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/parser_ll.l ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS parser_ll.l
  COMMENT "Copy parser_ll.l to CMake binary directory")
add_custom_target(parser_ll_l DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/parser_ll.l)

# Generate parser_ll.c using Flex
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/parser_ll.c
  COMMAND ${FLEX_EXECUTABLE} "-Pscotchyy${SCOTCH_NAME_SUFFIX}"  "-oparser_ll.c" parser_ll.l
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/parser_ll.l module.h common.h parser.h parser_ll.h parser_ly.h
  COMMENT "Generate parser_ll.c using Flex")
add_custom_target(parser_ll_c DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/parser_ll.c)
add_dependencies(parser_ll_c parser_ll_l)

###############
#  libScotch  #
###############

set(SCOTCH_C_SOURCES
  arch.c
  arch.h
  arch_build.c
  arch_build.h
  arch_build2.c
  arch_build2.h
  arch_cmplt.c
  arch_cmplt.h
  arch_cmpltw.c
  arch_cmpltw.h
  arch_deco.c
  arch_deco.h
  arch_deco2.c
  arch_deco2.h
  arch_dist.c
  arch_dist.h
  arch_hcub.c
  arch_hcub.h
  arch_mesh.c
  arch_mesh.h
  arch_tleaf.c
  arch_tleaf.h
  arch_sub.c
  arch_sub.h
  arch_torus.c
  arch_torus.h
  arch_vcmplt.c
  arch_vcmplt.h
  arch_vhcub.c
  arch_vhcub.h
  bgraph.c
  bgraph.h
  bgraph_bipart_bd.c
  bgraph_bipart_bd.h
  bgraph_bipart_df.c
  bgraph_bipart_df.h
  bgraph_bipart_ex.c
  bgraph_bipart_ex.h
  bgraph_bipart_fm.c
  bgraph_bipart_fm.h
  bgraph_bipart_gg.c
  bgraph_bipart_gg.h
  bgraph_bipart_gp.c
  bgraph_bipart_gp.h
  bgraph_bipart_ml.c
  bgraph_bipart_ml.h
  bgraph_bipart_st.c
  bgraph_bipart_st.h
  bgraph_bipart_zr.c
  bgraph_bipart_zr.h
  bgraph_cost.c
  bgraph_check.c
  bgraph_cost.c
  bgraph_store.c
  common.c
  common.h
  common_context.c
  common_error.c
  common_file.c
  common_file.h
  common_file_compress.c
  common_file_compress.h
  common_file_decompress.c
  common_integer.c
  common_memory.c
  common_string.c
  common_stub.c
  common_thread.c
  common_thread_system.c
  common_thread_system.h
  common_values.c
  common_values.h
  context.c
  context.h
  fibo.c
  fibo.h
  gain.c
  gain.h
  geom.c
  geom.h
  graph.c
  graph.h
  graph_band.c
  graph_base.c
  graph_check.c
  graph_clone.c
  graph_coarsen.c
  graph_coarsen.h
  graph_diam.c
  graph_ielo.c
  library_graph_induce.c
  graph_induce.c
  graph_induce.h
  graph_io.c
  graph_io.h
  graph_io_chac.c
  graph_io_habo.c
  graph_io_habo.h
  graph_io_mmkt.c
  graph_io_mmkt.h
  graph_io_scot.c
  graph_io_scot.h
  graph_list.c
  graph_list.h
  graph_match.c
  graph_match.h
  hall_order_hd.c
  hall_order_hd.h
  hall_order_hf.c
  hall_order_hf.h
  hall_order_hx.c
  hall_order_hx.h
  hgraph.c
  hgraph.h
  hgraph_check.c
  hgraph_induce.c
  hgraph_induce.h
  hgraph_order_bl.c
  hgraph_order_bl.h
  hgraph_order_cc.c
  hgraph_order_cc.h
  hgraph_order_cp.c
  hgraph_order_cp.h
  hgraph_order_gp.c
  hgraph_order_gp.h
  hgraph_order_hd.c
  hgraph_order_hd.h
  hgraph_order_hf.c
  hgraph_order_hf.h
  hgraph_order_hx.c
  hgraph_order_hx.h
  hgraph_order_kp.c
  hgraph_order_kp.h
  hgraph_order_nd.c
  hgraph_order_nd.h
  hgraph_order_si.c
  hgraph_order_si.h
  hgraph_order_st.c
  hgraph_order_st.h
  hmesh.c
  hmesh.h
  hmesh_check.c
  hmesh_hgraph.c
  hmesh_hgraph.h
  hmesh_induce.c
  hmesh_mesh.c
  hmesh_order_bl.c
  hmesh_order_bl.h
  hmesh_order_cp.c
  hmesh_order_cp.h
  hmesh_order_gp.c
  hmesh_order_gp.h
  hmesh_order_gr.c
  hmesh_order_gr.h
  hmesh_order_hd.c
  hmesh_order_hd.h
  hmesh_order_hf.c
  hmesh_order_hf.h
  hmesh_order_hx.c
  hmesh_order_hx.h
  hmesh_order_nd.c
  hmesh_order_nd.h
  hmesh_order_si.c
  hmesh_order_si.h
  hmesh_order_st.c
  hmesh_order_st.h
  kgraph.c
  kgraph.h
  kgraph_band.c
  kgraph_check.c
  kgraph_map_bd.c
  kgraph_map_bd.h
  kgraph_map_cp.c
  kgraph_map_cp.h
  kgraph_map_df.c
  kgraph_map_df.h
  kgraph_map_ex.c
  kgraph_map_ex.h
  kgraph_map_fm.c
  kgraph_map_fm.h
  kgraph_map_ml.c
  kgraph_map_ml.h
  kgraph_map_rb.c
  kgraph_map_rb.h
  kgraph_map_rb_map.c
  kgraph_map_rb_map.h
  kgraph_map_rb_part.c
  kgraph_map_rb_part.h
  kgraph_map_st.c
  kgraph_map_st.h
  kgraph_store.c
  library.h
  library_arch.c
  library_arch_build.c
  library_arch_build_f.c
  library_arch_dom.c
  library_arch_dom_f.c
  library_arch_f.c
  library_common_f.c
  library_context.c
  library_context_graph.c
  library_context_graph_f.c
  #library_errcom.c
  #library_error.c
  #library_error_exit.c
  library_f.h
  library_geom.c
  library_geom_f.c
  library_graph.c
  library_graph_base.c
  library_graph_base_f.c
  library_graph_check.c
  library_graph_check_f.c
  library_graph_coarsen.c
  library_graph_coarsen_f.c
  library_graph_color.c
  library_graph_color_f.c
  library_graph_diam.c
  library_graph_diam_f.c
  library_graph_f.c
  library_graph_io_chac.c
  library_graph_io_chac_f.c
  library_graph_io_habo.c
  library_graph_io_habo_f.c
  library_graph_io_mmkt.c
  library_graph_io_mmkt_f.c
  library_graph_io_scot.c
  library_graph_io_scot_f.c
  library_graph_map.c
  library_graph_map_f.c
  library_graph_map_io.c
  library_graph_map_io.h
  library_graph_map_io_f.c
  library_graph_map_view.c
  library_graph_map_view.h
  library_graph_map_view_f.c
  library_graph_order.c
  library_graph_order_f.c
  library_graph_part_ovl.c
  library_graph_part_ovl_f.c
  library_mapping.c
  library_mapping.h
  library_memory.c
  library_mesh.c
  library_mesh_f.c
  library_mesh_graph.c
  library_mesh_graph_f.c
  library_mesh_io_habo.c
  library_mesh_io_habo_f.c
  library_mesh_io_scot.c
  library_mesh_io_scot_f.c
  library_mesh_order.c
  library_mesh_order_f.c
  library_order.c
  library_order.h
  library_parser.c

=== src/libscotch/Makefile ===
## Copyright 2004,2007-2021,2023 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

includedir	= ../../include
libdir		= ../../lib

include ../Makefile.inc

CCDFLAGS	?= $(CFLAGS)

ifneq ($(strip $(SCOTCH_NAME_SUFFIX)),)
CFLAGS		+= -DSCOTCH_NAME_SUFFIX=$(SCOTCH_NAME_SUFFIX)
CCDFLAGS	+= -DSCOTCH_NAME_SUFFIX=$(SCOTCH_NAME_SUFFIX)
endif

##
##  General inference rules.
##

%$(OBJ)	:	%.c
				$(CC) $(CFLAGS) $(CLIBFLAGS) -c $(<) -o $(@) -DSCOTCH_VERSION_NUM=$(VERSION) -DSCOTCH_RELEASE_NUM=$(RELEASE) -DSCOTCH_PATCHLEVEL_NUM=$(PATCHLEVEL)

%$(EXE)	:	%.c
		 		$(CC) $(CFLAGS) -DSCOTCH_VERSION_NUM=$(VERSION) -DSCOTCH_RELEASE_NUM=$(RELEASE) -DSCOTCH_PATCHLEVEL_NUM=$(PATCHLEVEL) $(<) -o $(@) $(LDFLAGS)

##
##  Project rules.
##

.PHONY				:	ptscotch	scotch	ptinstall	install	clean	realclean

scotch				:
					$(MAKE) 					\
					CC="$(CCS)"					\
					CCD="$(CCS)"					\
					scotch.h					\
					scotchf.h					\
					libscotch$(LIB)					\
					libscotcherr$(LIB)				\
					libscotcherrexit$(LIB)

ptscotch			:	scotch
					$(MAKE) 					\
					CC="$(CCP)"					\
					CFLAGS="$(CFLAGS) -DSCOTCH_PTSCOTCH"		\
					CCDFLAGS="$(CCDFLAGS) -DSCOTCH_PTSCOTCH"	\
					ptscotch.h					\
					ptscotchf.h					\
					libptscotch$(LIB)				\
					libptscotcherr$(LIB)				\
					libptscotcherrexit$(LIB)

install				:	$(includedir)/scotch.h				\
					$(includedir)/scotchf.h				\
					$(libdir)/libscotch$(LIB)

ptinstall			:	install						\
					$(includedir)/ptscotch.h			\
					$(includedir)/ptscotchf.h			\
					$(libdir)/libptscotch$(LIB)

clean				:
					-$(RM) *~ *$(OBJ) lib*$(LIB) parser_yy.c parser_ly.h parser_ll.c *scotch.h *scotchf.h y.output *dummysizes$(EXE)

realclean			:	clean


##
##  Installation dependencies
##

$(includedir)/scotch.h		:	scotch.h
					-$(CP) scotch.h $(includedir)

$(includedir)/scotchf.h		:	scotchf.h
					-$(CP) scotchf.h $(includedir)

$(includedir)/ptscotch.h	:	ptscotch.h
					-$(CP) ptscotch.h $(includedir)

$(includedir)/ptscotchf.h	:	ptscotchf.h
					-$(CP) ptscotchf.h $(includedir)

$(libdir)/libscotch$(LIB)	:	libscotch$(LIB)
					-$(CP) libscotch$(LIB) libscotcherr*$(LIB) $(libdir)

$(libdir)/libptscotch$(LIB)	:	libptscotch$(LIB)
					-$(CP) libptscotch$(LIB) libptscotcherr*$(LIB) $(libdir)

##
##  Library dependencies.
##

LIBPTSCOTCHDEPS =	bdgraph$(OBJ)				\
			bdgraph_bipart_bd$(OBJ)			\
			bdgraph_bipart_df$(OBJ)			\
			bdgraph_bipart_ex$(OBJ)			\
			bdgraph_bipart_ml$(OBJ)			\
			bdgraph_bipart_sq$(OBJ)			\
			bdgraph_bipart_st$(OBJ)			\
			bdgraph_bipart_zr$(OBJ)			\
			bdgraph_check$(OBJ)			\
			bdgraph_gather_all$(OBJ)		\
			bdgraph_store$(OBJ)			\
			comm$(OBJ)				\
			dgraph$(OBJ)				\
			dgraph_allreduce$(OBJ)			\
			dgraph_band$(OBJ)			\
			dgraph_build$(OBJ)			\
			dgraph_build_grid3d$(OBJ)		\
			dgraph_build_hcub$(OBJ)			\
			dgraph_check$(OBJ)			\
			dgraph_coarsen$(OBJ)			\
			dgraph_compact$(OBJ)			\
			dgraph_fold$(OBJ)			\
			dgraph_fold_comm$(OBJ)			\
			dgraph_fold_dup$(OBJ)			\
			dgraph_gather$(OBJ)			\
			dgraph_gather_all$(OBJ)			\
			dgraph_ghst$(OBJ)			\
			dgraph_halo$(OBJ)			\
			dgraph_induce$(OBJ)			\
			dgraph_io_load$(OBJ)			\
			dgraph_io_save$(OBJ)			\
			dgraph_match$(OBJ)			\
			dgraph_match_sync_coll$(OBJ)		\
			dgraph_match_sync_ptop$(OBJ)		\
			dgraph_match_check$(OBJ)		\
			dgraph_redist$(OBJ)			\
			dgraph_scatter$(OBJ)			\
			dgraph_view$(OBJ)			\
			dmapping$(OBJ)				\
			dmapping_io$(OBJ)			\
			dorder$(OBJ)				\
			dorder_gather$(OBJ)			\
			dorder_io$(OBJ)				\
			dorder_io_block$(OBJ)			\
			dorder_io_tree$(OBJ)			\
			dorder_perm$(OBJ)			\
			dorder_tree_dist$(OBJ)			\
			hdgraph$(OBJ)				\
			hdgraph_check$(OBJ)			\
			hdgraph_fold$(OBJ)			\
			hdgraph_gather$(OBJ)			\
			hdgraph_induce$(OBJ)			\
			hdgraph_order_nd$(OBJ)			\
			hdgraph_order_si$(OBJ)			\
			hdgraph_order_sq$(OBJ)			\
			hdgraph_order_st$(OBJ)			\
			kdgraph$(OBJ)				\
			kdgraph_gather$(OBJ)			\
			kdgraph_map_rb$(OBJ)			\
			kdgraph_map_rb_map$(OBJ)		\
			kdgraph_map_rb_part$(OBJ)		\
			kdgraph_map_st$(OBJ)			\
			library_context_dgraph$(OBJ)		\
			library_context_dgraph_f$(OBJ)		\
			library_dgraph$(OBJ)			\
			library_dgraph_f$(OBJ)			\
			library_dgraph_band$(OBJ)		\
			library_dgraph_band_f$(OBJ)		\
			library_dgraph_build$(OBJ)		\
			library_dgraph_build_f$(OBJ)		\
			library_dgraph_build_grid3d$(OBJ)	\
			library_dgraph_build_grid3d_f$(OBJ)	\
			library_dgraph_check$(OBJ)		\
			library_dgraph_check_f$(OBJ)		\
			library_dgraph_coarsen$(OBJ)		\
			library_dgraph_coarsen_f$(OBJ)		\
			library_dgraph_gather$(OBJ)		\
			library_dgraph_gather_f$(OBJ)		\
			library_dgraph_grow$(OBJ)		\
			library_dgraph_halo$(OBJ)		\
			library_dgraph_halo_f$(OBJ)		\
			library_dgraph_induce$(OBJ)		\
			library_dgraph_induce_f$(OBJ)		\
			library_dgraph_io_load$(OBJ)		\
			library_dgraph_io_load_f$(OBJ)		\
			library_dgraph_io_save$(OBJ)		\
			library_dgraph_io_save_f$(OBJ)		\
			library_dgraph_map$(OBJ)		\
			library_dgraph_map_f$(OBJ)		\
			library_dgraph_map_view$(OBJ)		\
			library_dgraph_map_view_f$(OBJ)		\
			library_dgraph_order$(OBJ)		\
			library_dgraph_order_f$(OBJ)		\
			library_dgraph_order_gather$(OBJ)	\
			library_dgraph_order_gather_f$(OBJ)	\
			library_dgraph_order_io$(OBJ)		\
			library_dgraph_order_io_f$(OBJ)		\
			library_dgraph_order_io_block$(OBJ)	\
			library_dgraph_order_io_block_f$(OBJ)	\
			library_dgraph_order_perm$(OBJ)		\
			library_dgraph_order_perm_f$(OBJ)	\
			library_dgraph_order_tree_dist$(OBJ)	\
			library_dgraph_order_tree_dist_f$(OBJ)	\
			library_dgraph_redist$(OBJ)		\
			library_dgraph_redist_f$(OBJ)		\
			library_dgraph_scatter$(OBJ)		\
			library_dgraph_scatter_f$(OBJ)		\
			library_dgraph_stat$(OBJ)		\
			library_dgraph_stat_f$(OBJ)		\
			library_dmapping$(OBJ)			\
			library_dorder$(OBJ)			\
			vdgraph$(OBJ)				\
			vdgraph_check$(OBJ)			\
			vdgraph_gather_all$(OBJ)		\
			vdgraph_separate_bd$(OBJ)		\
			vdgraph_separate_df$(OBJ)		\
			vdgraph_separate_ml$(OBJ)		\
			vdgraph_separate_sq$(OBJ)		\
			vdgraph_separate_st$(OBJ)		\
			vdgraph_separate_zr$(OBJ)		\
			vdgraph_store$(OBJ)

LIBSCOTCHDEPS	=	arch$(OBJ)				\
			arch_build$(OBJ)			\
			arch_build2$(OBJ)			\
			arch_cmplt$(OBJ)			\
			arch_cmpltw$(OBJ)			\
			arch_deco$(OBJ)				\
			arch_deco2$(OBJ)			\
			arch_dist$(OBJ)				\
			arch_hcub$(OBJ)				\
			arch_mesh$(OBJ)				\
			arch_sub$(OBJ)				\
			arch_tleaf$(OBJ)			\
			arch_torus$(OBJ)			\
			arch_vcmplt$(OBJ)			\
			arch_vhcub$(OBJ)			\
			bgraph$(OBJ)				\
			bgraph_bipart_bd$(OBJ)			\
			bgraph_bipart_df$(OBJ)			\
			bgraph_bipart_ex$(OBJ)			\
			bgraph_bipart_fm$(OBJ)			\
			bgraph_bipart_gg$(OBJ)			\
			bgraph_bipart_gp$(OBJ)			\
			bgraph_bipart_ml$(OBJ)			\
			bgraph_bipart_st$(OBJ)			\
			bgraph_bipart_zr$(OBJ)			\
			bgraph_check$(OBJ)			\
			bgraph_cost$(OBJ)			\
			bgraph_store$(OBJ)			\
			common$(OBJ)				\
			common_context$(OBJ)			\
			common_file$(OBJ)			\
			common_file_compress$(OBJ)		\
			common_file_decompress$(OBJ)		\
			common_integer$(OBJ)			\
			common_memory$(OBJ)			\
			common_string$(OBJ)			\
			common_stub$(OBJ)			\
			common_thread$(OBJ)			\
			common_thread_system$(OBJ)		\
			common_values$(OBJ)			\
			context$(OBJ)				\
			fibo$(OBJ)				\
			gain$(OBJ)				\
			geom$(OBJ)				\
			graph$(OBJ)				\
			graph_base$(OBJ)			\
			graph_band$(OBJ)			\
			graph_check$(OBJ)			\
			graph_clone$(OBJ)			\
			graph_coarsen$(OBJ)			\
			graph_diam$(OBJ)			\
			graph_dump$(OBJ)			\
			graph_ielo$(OBJ)			\
			graph_induce$(OBJ)			\
			graph_io$(OBJ)				\
			graph_io_chac$(OBJ)			\
			graph_io_habo$(OBJ)			\
			graph_io_mmkt$(OBJ)			\
			graph_io_scot$(OBJ)			\
			graph_list$(OBJ)			\
			graph_match$(OBJ)			\
			hall_order_hd$(OBJ)			\
			hall_order_hf$(OBJ)			\
			hall_order_hx$(OBJ)			\
			hgraph$(OBJ)				\
			hgraph_check$(OBJ)			\
			hgraph_dump$(OBJ)			\
			hgraph_induce$(OBJ)			\
			hgraph_order_bl$(OBJ)			\
			hgraph_order_cc$(OBJ)			\
			hgraph_order_cp$(OBJ)			\
			hgraph_order_gp$(OBJ)			\
			hgraph_order_hd$(OBJ)			\
			hgraph_order_hf$(OBJ)			\
			hgraph_order_hx$(OBJ)			\
			hgraph_order_kp$(OBJ)			\
			hgraph_order_nd$(OBJ)			\
			hgraph_order_si$(OBJ)			\
			hgraph_order_st$(OBJ)			\
			hmesh$(OBJ)				\
			hmesh_check$(OBJ)			\
			hmesh_hgraph$(OBJ)			\
			hmesh_induce$(OBJ)			\
			hmesh_mesh$(OBJ)			\
			hmesh_order_bl$(OBJ)			\
			hmesh_order_cp$(OBJ)			\
			hmesh_order_gr$(OBJ)			\
			hmesh_order_gp$(OBJ)			\
			hmesh_order_hd$(OBJ)			\
			hmesh_order_hf$(OBJ)			\
			hmesh_order_hx$(OBJ)			\
			hmesh_order_nd$(OBJ)			\
			hmesh_order_si$(OBJ)			\
			hmesh_order_st$(OBJ)			\
			kgraph$(OBJ)				\
			kgraph_band$(OBJ)			\
			kgraph_check$(OBJ)			\
			kgraph_map_bd$(OBJ)			\
			kgraph_map_cp$(OBJ)			\
			kgraph_map_df$(OBJ)			\
			kgraph_map_ex$(OBJ)			\
			kgraph_map_fm$(OBJ)			\
			kgraph_map_ml$(OBJ)			\
			kgraph_map_rb$(OBJ)			\
			kgraph_map_rb_map$(OBJ)			\
			kgraph_map_rb_part$(OBJ)		\
			kgraph_map_st$(OBJ)			\
			kgraph_store$(OBJ)			\
			library_arch$(OBJ)			\
			library_arch_f$(OBJ)			\
			library_arch_build$(OBJ)		\
			library_arch_build_f$(OBJ)		\
			library_arch_dom$(OBJ)			\
			library_arch_dom_f$(OBJ)		\
			library_common_f$(OBJ)			\
			library_context$(OBJ)			\
			library_context_f$(OBJ)			\
			library_context_graph$(OBJ)		\
			library_context_graph_f$(OBJ)		\
			library_context_mesh$(OBJ)		\
			library_context_mesh_f$(OBJ)		\
			library_geom$(OBJ)			\
			library_geom_f$(OBJ)			\
			library_graph$(OBJ)			\
			library_graph_f$(OBJ)			\
			library_graph_base$(OBJ)		\
			library_graph_base_f$(OBJ)		\
			library_graph_check$(OBJ)		\
			library_graph_check_f$(OBJ)		\
			library_graph_coarsen$(OBJ)		\
			library_graph_coarsen_f$(OBJ)		\
			library_graph_color$(OBJ)		\
			library_graph_color_f$(OBJ)		\
			library_graph_diam$(OBJ)		\
			library_graph_diam_f$(OBJ)		\
			library_graph_dump$(OBJ)		\
			library_graph_induce$(OBJ)		\
			library_graph_induce_f$(OBJ)		\
			library_graph_io_chac$(OBJ)		\
			library_graph_io_chac_f$(OBJ)		\
			library_graph_io_habo$(OBJ)		\
			library_graph_io_habo_f$(OBJ)		\
			library_graph_io_mmkt$(OBJ)		\
			library_graph_io_mmkt_f$(OBJ)		\
			library_graph_io_scot$(OBJ)		\
			library_graph_io_scot_f$(OBJ)		\
			library_graph_map$(OBJ)			\
			library_graph_map_f$(OBJ)		\
			library_graph_map_io$(OBJ)		\
			library_graph_map_io_f$(OBJ)		\
			library_graph_map_view$(OBJ)		\
			library_graph_map_view_f$(OBJ)		\
			library_graph_order$(OBJ)		\
			library_graph_order_f$(OBJ)		\

=== src/libscotchmetis/CMakeLists.txt ===
## Copyright 2014-2016,2021,2022 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##
############################################################
##                                                        ##
##   AUTHORS    : Cedric LACHAT                           ##
##                Amaury JACQUES                          ##
##                Florent PRUVOST                         ##
##                Marc FUENTES                            ##
##                                                        ##
##   FUNCTION   : Secondary configuration file for CMake  ##
##                                                        ##
##   DATES      : # Version 6.0  : from : 01 sep 2014     ##
##                                 to     01 sep 2021     ##
##                # Version 7.0  : from : 01 sep 2021     ##
##                                 to     08 jan 2022     ##
##                                                        ##
############################################################

####################
#  libScotchMeTiS  #
####################

set_source_files_properties(${GENERATED_INCLUDE_DIR}/scotch.h PROPERTIES GENERATED 1)
set_source_files_properties(${GENERATED_INCLUDE_DIR}/metis.h PROPERTIES GENERATED 1)

# metis.h
add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/metis.h
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/library_metis.h ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $<TARGET_FILE:dummysizes> ${CMAKE_CURRENT_BINARY_DIR}/library_metis.h ${GENERATED_INCLUDE_DIR}/metis.h DEPENDS dummysizes
  DEPENDS library_metis.h
  COMMENT "Generating metis.h")

add_custom_target(metis_h
  DEPENDS "${GENERATED_INCLUDE_DIR}/metis.h")

# metisf.h
add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/metisf.h
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/library_metis_f.h ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $<TARGET_FILE:dummysizes> ${CMAKE_CURRENT_BINARY_DIR}/library_metis_f.h ${GENERATED_INCLUDE_DIR}/metisf.h DEPENDS dummysizes
  DEPENDS library_metis_f.h
  COMMENT "Generating metisf.h")

add_custom_target(metisf_h
  DEPENDS "${GENERATED_INCLUDE_DIR}/metisf.h")

# libScotchMeTiS
foreach(version 3 5)
  add_library(scotchmetisv${version}
    metis_graph_order.c
    metis_graph_order_f.c
    metis_graph_part.c
    metis_graph_part_f.c
    metis_graph_dual.c
    metis_graph_dual_f.c
    metis_graph_part_dual.c
    metis_graph_part_dual_f.c
    metis_options.c
    metis_options_f.c
    ${LIBSCOTCH_INCLUDE_DIR}/module.h
    ${LIBSCOTCH_INCLUDE_DIR}/common.h
    ${GENERATED_INCLUDE_DIR}/scotch.h
    ${GENERATED_INCLUDE_DIR}/metis.h
    ${GENERATED_INCLUDE_DIR}/metisf.h)

  target_compile_definitions(scotchmetisv${version} PUBLIC SCOTCH_METIS_VERSION=${version})

  target_include_directories(scotchmetisv${version} PRIVATE
    $<BUILD_INTERFACE:${LIBSCOTCH_INCLUDE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${GENERATED_INCLUDE_DIR}>
    $<INSTALL_INTERFACE:include>)

  target_link_libraries(scotchmetisv${version} PRIVATE scotch)

  add_dependencies(scotchmetisv${version} scotch_h metisf_h)
  if(INSTALL_METIS_HEADERS)
    set_target_properties(scotchmetisv${version} PROPERTIES PUBLIC_HEADER "${GENERATED_INCLUDE_DIR}/metis.h;${GENERATED_INCLUDE_DIR}/metisf.h")
  endif()

  if(APPLE)
    set_target_properties(scotchmetisv${version} PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
  endif(APPLE)

  # libScotchMeTiS targets install
  install(EXPORT scotchmetisTargets
    FILE scotchmetisTargets.cmake
    NAMESPACE SCOTCH::
    DESTINATION lib/cmake/scotch)
  if(INSTALL_METIS_HEADERS)
    install(TARGETS scotchmetisv${version}
      EXPORT scotchmetisTargets
      ARCHIVE DESTINATION lib
      LIBRARY DESTINATION lib
      PUBLIC_HEADER DESTINATION include)
  else()
    install(TARGETS scotchmetisv${version}
      EXPORT scotchmetisTargets
      ARCHIVE DESTINATION lib
      LIBRARY DESTINATION lib)
  endif()
endforeach(version 3 5)

#########################
#  libPTScotchParMeTiS  #
#########################

if(BUILD_PTSCOTCH)
  set_source_files_properties(${GENERATED_INCLUDE_DIR}/ptscotch.h PROPERTIES GENERATED 1)

  # parmetis.h
  add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/parmetis.h
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/library_parmetis.h ${CMAKE_CURRENT_BINARY_DIR}
    COMMAND $<TARGET_FILE:dummysizes> ${CMAKE_CURRENT_BINARY_DIR}/library_parmetis.h ${GENERATED_INCLUDE_DIR}/parmetis.h DEPENDS dummysizes
    DEPENDS library_parmetis.h
    COMMENT "Generating parmetis.h")

  add_custom_target(parmetis_h
    DEPENDS "${GENERATED_INCLUDE_DIR}/parmetis.h")

  # libPTScotchParMeTiS
  foreach(version 3)
    add_library(ptscotchparmetisv${version}
      parmetis_dgraph_order.c
      parmetis_dgraph_order_f.c
      parmetis_dgraph_part.c
      parmetis_dgraph_part_f.c
      ${LIBSCOTCH_INCLUDE_DIR}/module.h
      ${LIBSCOTCH_INCLUDE_DIR}/common.h
      ${GENERATED_INCLUDE_DIR}/ptscotch.h
      ${GENERATED_INCLUDE_DIR}/parmetis.h)

    target_compile_definitions(ptscotchparmetisv${version} PUBLIC SCOTCH_PTSCOTCH SCOTCH_METIS_VERSION=${version})

    target_include_directories(ptscotchparmetisv${version} PRIVATE
      $<BUILD_INTERFACE:${LIBSCOTCH_INCLUDE_DIR}>
      $<BUILD_INTERFACE:${GENERATED_INCLUDE_DIR}>
      $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
      $<INSTALL_INTERFACE:include>)

    target_link_libraries(ptscotchparmetisv${version} PRIVATE scotch)
    target_link_libraries(ptscotchparmetisv${version} PRIVATE ptscotch)
    target_link_libraries(ptscotchparmetisv${version} PUBLIC MPI::MPI_C)

    add_dependencies(ptscotchparmetisv${version} ptscotch_h)
    if(INSTALL_METIS_HEADERS)
      set_target_properties(ptscotchparmetisv${version} PROPERTIES PUBLIC_HEADER "${GENERATED_INCLUDE_DIR}/parmetis.h")
    endif()

    if(APPLE)
      set_target_properties(ptscotchparmetisv${version} PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
    endif(APPLE)

    # libPTScotchParMeTiS targets install
    install(EXPORT ptscotchparmetisTargets
      FILE ptscotchparmetisTargets.cmake
      NAMESPACE SCOTCH::
      DESTINATION lib/cmake/scotch)

    if(INSTALL_METIS_HEADERS)
      install(TARGETS ptscotchparmetisv${version}
        EXPORT ptscotchparmetisTargets
        ARCHIVE DESTINATION lib
        LIBRARY DESTINATION lib
        PUBLIC_HEADER DESTINATION include)
    else()
      install(TARGETS ptscotchparmetisv${version}
        EXPORT ptscotchparmetisTargets
        ARCHIVE DESTINATION lib
        LIBRARY DESTINATION lib)
    endif()
  endforeach(version 3)
endif(BUILD_PTSCOTCH)

=== src/scotch/CMakeLists.txt ===
## Copyright 2014-2016,2021,2022 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##
############################################################
##                                                        ##
##   AUTHORS    : Marc FUENTES                            ##
##                Florent PRUVOST                         ##
##                Cedric LACHAT                           ##
##                Amaury JACQUES                          ##
##                                                        ##
##   FUNCTION   : Secondary configuration file for CMake  ##
##                                                        ##
##   DATES      : # Version 6.0  : from : 01 sep 2014     ##
##                                 to     01 sep 2021     ##
##                # Version 7.0  : from : 01 sep 2021     ##
##                                 to     04 feb 2022     ##
##                                                        ##
############################################################

set_source_files_properties(${GENERATED_INCLUDE_DIR}/scotch.h PROPERTIES GENERATED 1)

# Macro to add quickly simple exectubles linked against the libScotch library
function(add_scotch_exe)
  if(ARGC LESS_EQUAL 0)
    message(FATAL_ERROR "Macro add_scotch_exe requires arguments")
  endif()
  set(file_we ${ARGV0})
  if(ARGC GREATER_EQUAL 2)
    set(src_exe ${ARGV})
    list(REMOVE_AT src_exe 0)
  elseif(ARGC EQUAL 1)
    set(src_exe ${file_we}.c ${file_we}.h)
  endif()
  add_executable(${file_we}
    ${src_exe}
    ${LIBSCOTCH_INCLUDE_DIR}/module.h
    ${GENERATED_INCLUDE_DIR}/scotch.h
    ${LIBSCOTCH_INCLUDE_DIR}/common.h)
  add_dependencies(${file_we} scotch_h)
  target_include_directories(${file_we} PRIVATE ${GENERATED_INCLUDE_DIR})
  target_compile_definitions(${file_we} PUBLIC "SCOTCH_CODENAME=\"${SCOTCH_CODENAME}\"")
  if(Threads_FOUND)
    target_compile_definitions(${file_we} PUBLIC SCOTCH_PTHREAD COMMON_PTHREAD)
    target_link_libraries(${file_we} PUBLIC Threads::Threads)
  endif(Threads_FOUND)
  target_link_libraries(${file_we} PUBLIC scotch scotcherrexit)
endfunction(add_scotch_exe)

# Scotch executables
set(scotch_exe
  acpl
  amk_ccc
  amk_fft2
  amk_grf
  amk_hy
  amk_m2
  amk_p2
  atst
  gbase
  gcv
  gmap
  gmk_hy
  gmk_m2
  gmk_m3
  gmk_msh
  gmk_ub2
  gmtst
  gord
  gotst
  gscat
  gtst
  mcv
  mmk_m2
  mmk_m3
  mord
  mtst)

# Generic target
foreach(target ${scotch_exe})
  add_scotch_exe(${target})
endforeach()

# Targets which need special source lists
add_scotch_exe(gout gout_c.c gout_o.c)
target_link_libraries(gout PRIVATE m)

# gpart is a special target (same source as gmap)
add_scotch_exe(gpart gmap.c gmap.h)
target_compile_definitions(gpart PRIVATE SCOTCH_COMPILE_PART)

# Install all Scotch executables
foreach(target ${scotch_exe})
  install(TARGETS ${target} RUNTIME DESTINATION bin)
endforeach()

# Executables linked against the libPTScotch library
if(BUILD_PTSCOTCH)
  set_source_files_properties(${GENERATED_INCLUDE_DIR}/ptscotch.h PROPERTIES GENERATED 1)
  function(add_ptscotch_exe)
    if(ARGC LESS_EQUAL 0)
      message(FATAL_ERROR "Macro add_ptscotch_exe requires arguments")
    endif()
    set(file_we ${ARGV0})
    if(ARGC GREATER_EQUAL 2)
      set(src_exe ${ARGV})
      list(REMOVE_AT src_exe 0)
    elseif(ARGC EQUAL 1)
      set(src_exe ${file_we}.c ${file_we}.h)
    endif()
    add_executable(${file_we}
      ${src_exe}
      ${LIBSCOTCH_INCLUDE_DIR}/module.h
      ${LIBSCOTCH_INCLUDE_DIR}/common.h
      ${GENERATED_INCLUDE_DIR}/ptscotch.h)
    add_dependencies(${file_we} ptscotch_h)
    target_compile_definitions(${file_we} PUBLIC "SCOTCH_CODENAME=\"${SCOTCH_CODENAME}\"")
    if(Threads_FOUND)
      target_compile_definitions(${file_we} PUBLIC SCOTCH_PTHREAD COMMON_PTHREAD)
      target_link_libraries(${file_we} PUBLIC Threads::Threads)
    endif(Threads_FOUND)
    target_include_directories(${file_we} PRIVATE ${GENERATED_INCLUDE_DIR})
    target_link_libraries(${file_we} PUBLIC scotch ptscotch ptscotcherrexit)
  endfunction(add_ptscotch_exe)

  set(ptscotch_exe
    dggath
    dgmap
    dgord
    dgscat
    dgtst)

  # Generic PT-Scotch targets
  foreach(target ${ptscotch_exe})
    add_ptscotch_exe(${target})
  endforeach()
  add_ptscotch_exe(dgpart dgmap.c dgmap.h)
  target_compile_definitions(dgpart PRIVATE SCOTCH_COMPILE_PART)
  # Install all PT-Scotch executables
  foreach(target ${ptscotch_exe})
     install(TARGETS ${target} RUNTIME DESTINATION bin)
  endforeach()
 endif(BUILD_PTSCOTCH)

=== debian/changelog ===
scotch (7.0.4-1ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:38:40 +1100

scotch (7.0.4-1ubuntu1) noble; urgency=medium

  * Pass -D_FORTIFY_SOURCE=2 to work around the compiler incorrectly
    annotating some questionable pointers and causing a buffer overflow
    assertion at runtime. (Ref LP #2058094)

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 23:13:02 -0700

scotch (7.0.4-1build1) noble; urgency=medium

  * No-change rebuild against libopenmpi3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 18:36:19 +0000

scotch (7.0.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Mon, 04 Sep 2023 16:04:24 +0200

=== debian/control ===
Source: scotch
Section: math
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>,
 Andreas Tille <tille@debian.org>
Build-Depends: debhelper-compat (= 13),
    gfortran | fortran-compiler,
    bison, flex,
    zlib1g-dev,
    libbz2-dev,
    liblzma-dev,
    chrpath,
    mpi-default-dev, mpi-default-bin
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/science-team/scotch.git
Vcs-Browser: https://salsa.debian.org/science-team/scotch
Homepage: http://www.labri.fr/perso/pelegrin/scotch/

Package: scotch
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Its purpose is to apply graph theory, with a divide and conquer
 approach, to scientific computing problems such as graph and mesh
 partitioning, static mapping, and sparse matrix ordering, in
 application domains ranging from structural mechanics to operating
 systems or bio-chemistry.
 .
 The SCOTCH distribution is a set of programs and libraries which
 implement the static mapping and sparse matrix reordering algorithms
 developed within the SCOTCH project.
 .
 SCOTCH has many interesting features:
 .
 o Its capabilities can be used through a set of stand-alone programs
 as well as through the libSCOTCH library, which offers both C and
 Fortran interfaces.
 .
 o It provides algorithms to partition graph structures, as well as
 mesh structures defined as node-element bipartite graphs and which
 can also represent hypergraphs.
 .
 o It can map any weighted source graph onto any weighted target
 graph. The source and target graphs may have any topology, and their
 vertices and edges may be weighted. Moreover, both source and target
 graphs may be disconnected. This feature allows for the mapping of
 programs onto disconnected subparts of a parallel architecture made
 up of heterogeneous processors and communication links.
 .
 o It computes amalgamated block orderings of sparse matrices, for
 efficient solving using BLAS routines.
 .
 o Its running time is linear in the number of edges of the source
 graph, and logarithmic in the number of vertices of the target graph
 for mapping computations.
 .
 o It can handle indifferently graph and mesh data structures created
 within C or Fortran programs, with array indices starting from 0 or
 1.
 .
 o It offers extended support for adaptive graphs and meshes through
 the handling of disjoint edge arrays.
 .
 o It is dynamically parametrizable thanks to strategy strings that
 are interpreted at run-time.
 .
 o It uses system memory efficiently, to process large graphs and
 meshes without incurring out-of-memory faults;
 .
 o It is highly modular and documented. Since it has been released
 under the CeCILL-C free/libre software license, it can be used as a
 testbed for the easy and quick development and testing of new
 partitioning and ordering methods.
 .
 o It can be easily interfaced to other programs. The programs
 comprising the SCOTCH project have been designed to run in
 command-line mode without any interactive prompting, so that they can
 be called easily from other programs by means of system() or popen()
 calls, or piped together on a single command line. Moreover, vertex
 labeling capabilities allow for easy renumbering of vertices.
 .
 o It provides many tools to build, check, and display graphs, meshes
 and matrix patterns.
 .
 o It is written in C and uses the POSIX interface, which makes it
 highly portable. PT-SCOTCH uses the MPI interface, and optionally the
 POSIX threads.

Package: ptscotch
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 PT-SCOTCH is the MPI version of scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.

Package: libscotch-dev
Section: libdevel
Architecture: any
Depends: libscotch-7.0 (= ${binary:Version}), mpi-default-dev, zlib1g-dev, ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Headers and libraries package for scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.

Package: libptscotch-dev
Section: libdevel
Architecture: any
Depends: libptscotch-7.0 (= ${binary:Version}), libscotch-dev (= ${binary:Version}), mpi-default-dev, zlib1g-dev, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 Headers and libraries package for PT-SCOTCH, the MPI version of scotch, which
 is a set of programs and libraries which implement the static mapping and
 sparse matrix reordering algorithms developed within the SCOTCH project.

Package: libscotchmetis-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libscotch-dev (= ${binary:Version}), ${misc:Depends}
Conflicts: libmetis-dev, libparmetis-dev
Replaces: libmetis-dev
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Scotch/Metis compatility interface, providing a free implementation of the
 Metis system for graph partitioning and sparse matrix reordering.

Package: libscotchparmetis-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libptscotch-dev (= ${binary:Version}), ${misc:Depends}
Conflicts: libparmetis-dev
Replaces: libparmetis-dev
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Scotch/ParMetis compatility interface, providing a free implementation of the
 ParMetis system for parallel graph partitioning and sparse matrix reordering.

Package: libscotch-7.0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Shared libraries package for scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.

Package: libptscotch-7.0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 Shared libraries package for PT-SCOTCH, the MPI version of scotch, which
 is a set of programs and libraries which implement the static mapping and
 sparse matrix reordering algorithms developed within the SCOTCH project.
